export class CoreoMapTilelayerComponent {
    constructor() {
        this.layerTitle = 'OSM Tile Layer';
        this.url = 'http://{s}.tile.osm.org/{z}/{x}/{y}.png';
        this.attribution = '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors';
    }
    componentDidLoad() {
        console.log('[coreo-map-tilelayer] componentDidLoad');
        const layer = L.tileLayer(this.url, {
            attribution: this.attribution
        });
        this.registerLayer.emit({ layer, promise: Promise.resolve(), title: this.layerTitle, type: "base" });
    }
    static get is() { return "coreo-map-tilelayer"; }
    static get properties() { return {
        "attribution": {
            "type": String,
            "attr": "attribution"
        },
        "el": {
            "elementRef": true
        },
        "layerTitle": {
            "type": String,
            "attr": "layer-title"
        },
        "url": {
            "type": String,
            "attr": "url"
        }
    }; }
    static get events() { return [{
            "name": "registerLayer",
            "method": "registerLayer",
            "bubbles": true,
            "cancelable": true,
            "composed": true
        }]; }
}
