const getRecords = (id) => {
    console.log(id);
    return Promise.resolve({ data: { records: [] } });
};
export class CoreoPiechartComponent {
    componentDidLoad() {
        var canvas = document.getElementById('coreo_piechart');
        var ctx = canvas.getContext('2d');
        getRecords(22).then(response => {
            let records = response.data.records;
            let recordsProcessed = records.reduce((acc, record) => {
                if (!acc.hasOwnProperty(record.species)) {
                    acc[record.species] = 0;
                }
                if (record.count < 10) {
                    acc[record.species] += +record.count;
                }
                return acc;
            }, {});
            let labels = [], data = [];
            for (let i in recordsProcessed) {
                labels.push(i);
                data.push(recordsProcessed[i]);
            }
            this.chart = new Chart(ctx, {
                type: 'bar',
                data: {
                    labels,
                    datasets: [{
                            label: 'Species Test',
                            data,
                            backgroundColor: [
                                'rgba(255, 99, 132, 0.2)',
                                'rgba(54, 162, 235, 0.2)',
                                'rgba(255, 206, 86, 0.2)',
                                'rgba(75, 192, 192, 0.2)',
                                'rgba(153, 102, 255, 0.2)',
                                'rgba(255, 159, 64, 0.2)'
                            ],
                            borderColor: [
                                'rgba(255,99,132,1)',
                                'rgba(54, 162, 235, 1)',
                                'rgba(255, 206, 86, 1)',
                                'rgba(75, 192, 192, 1)',
                                'rgba(153, 102, 255, 1)',
                                'rgba(255, 159, 64, 1)'
                            ],
                            borderWidth: 1
                        }]
                },
                options: {
                    scales: {
                        yAxes: [{
                                ticks: {
                                    beginAtZero: true
                                }
                            }]
                    }
                }
            });
        });
    }
    render() {
        return (h("div", null,
            h("canvas", { id: "coreo_piechart" })));
    }
    static get is() { return "coreo-piechart"; }
    static get properties() { return {
        "el": {
            "elementRef": true
        }
    }; }
    static get style() { return "/**style-placeholder:coreo-piechart:**/"; }
}
