export class CoreoRecordCardComponent {
    constructor() {
        this.photoField = 'photo';
    }
    componentWillLoad() {
        this.apiCtrl.create().then(api => api.graphql(`record(id: ${this.recordId}){ id,createdAt,data,user{displayName},survey{attributes(limit: 5){label,order,field{path}}} }`).then(response => this.record = response.data.record));
    }
    render() {
        if (!this.record) {
            return;
        }
        const { data, createdAt, survey: { attributes }, user: { displayName } } = this.record;
        const img = data[this.photoField];
        return (h("div", { class: "record" },
            h("div", { class: "thumb" },
                h("img", { src: img, alt: "thumbnail" })),
            h("div", { class: "details" },
                h("a", { href: "#", class: "view" }, "View record"),
                h("p", { class: "date" }, createdAt),
                h("p", null,
                    "Submitted by ",
                    displayName),
                h("ul", null, attributes.map(attribute => {
                    return h("li", null,
                        h("span", null, attribute.label),
                        data[attribute.field.path]);
                })))));
    }
    static get is() { return "coreo-record-card"; }
    static get properties() { return {
        "apiCtrl": {
            "connect": "coreo-api"
        },
        "photoField": {
            "type": String,
            "attr": "photo-field"
        },
        "record": {
            "state": true
        },
        "recordId": {
            "type": String,
            "attr": "record-id"
        }
    }; }
    static get style() { return "/**style-placeholder:coreo-record-card:**/"; }
}
