import { parseIds } from '../../utils';
export class CoreoRecordCardsComponent {
    constructor() {
        this.limit = 10;
        this.records = [];
    }
    componentWillLoad() {
        let surveyIds = parseIds(this.surveyId);
        this.apiCtrl.create().then(api => api.graphql(`records( limit: ${this.limit}, where: { surveyId: { in: [ ${surveyIds.join(',')}] }}){ id,createdAt,data,user{displayName},survey{attributes(limit: 5){label,order,field{path}}} }`).then(response => this.records = response.data.records));
    }
    render() {
        if (!this.records.length) {
            return;
        }
        console.log('HERE', this.records);
        return this.records.map(record => h("coreo-record-card", { "record-id": record.id }));
    }
    static get is() { return "coreo-record-cards"; }
    static get properties() { return {
        "apiCtrl": {
            "connect": "coreo-api"
        },
        "limit": {
            "type": Number,
            "attr": "limit"
        },
        "records": {
            "state": true
        },
        "surveyId": {
            "type": String,
            "attr": "survey-id"
        }
    }; }
}
