export class CoreoRecordImageComponent {
    constructor() {
        this.alt = "";
    }
    validateRecordId(newValue, _oldValue) {
        const isEmpty = typeof newValue == null;
        if (isEmpty) {
            throw new Error("<coreo-record-image /> ERROR: 'record-id' is a required property");
        }
        ;
    }
    validatePath(newValue, _oldValue) {
        const isEmpty = typeof newValue == null;
        if (isEmpty) {
            throw new Error("<coreo-record-image /> ERROR: 'path' is a required property");
        }
        ;
    }
    componentWillLoad() {
        this.apiCtrl.create().then(api => {
            this.src = api.getSrc();
        });
    }
    render() {
        if (!this.src) {
            return;
        }
        let image = null;
        if (this.recordId && this.path) {
            const source = `${this.src}/records/${this.recordId}/images/${this.path}`;
            image = h("img", { class: "coreo-record-image", src: source, alt: this.alt });
        }
        return image;
    }
    static get is() { return "coreo-record-image"; }
    static get properties() { return {
        "alt": {
            "type": String,
            "attr": "alt"
        },
        "apiCtrl": {
            "connect": "coreo-api"
        },
        "el": {
            "elementRef": true
        },
        "path": {
            "type": String,
            "attr": "path",
            "watchCallbacks": ["validatePath"]
        },
        "recordId": {
            "type": Number,
            "attr": "record-id",
            "watchCallbacks": ["validateRecordId"]
        },
        "src": {
            "state": true
        }
    }; }
    static get style() { return "/**style-placeholder:coreo-record-image:**/"; }
}
