/*! Built with http://stenciljs.com */
import { h } from '../coreo.core.js';

const parseIds = (str) => {
    let j;
    try {
        j = JSON.parse(str);
    }
    catch (e) {
        return [];
    }
    return Array.isArray(j) ? j : [j];
};
const generateRandomString = (stringLength) => {
    const possible = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    return Array.from({ length: stringLength }, () => {
        return possible[Math.floor(Math.random() * possible.length)];
    }).join('');
};
const base64ToBase64url = function (b64) {
    return b64.replace('_', '/').replace('-', '+');
};
const decodeAuthToken = (token) => JSON.parse(atob(base64ToBase64url(token.split('.')[1])));

export { decodeAuthToken as a, parseIds as b, generateRandomString as c };
