/*! Built with http://stenciljs.com */
import { h } from '../coreo.core.js';

class CoreoRecordCountComponent {
    constructor() {
        this.syncError = false;
    }
    componentWillLoad() {
        if (this.apiCtrl) {
            try {
                this.apiCtrl.create().then(api => {
                    this.apiService = api;
                    this._update();
                });
            }
            catch (error) {
                console.error("SyncError: Coreo API error:\n", error);
                this.syncError = true;
            }
        }
        else {
            console.error("SyncError: Coreo API not found");
            this.syncError = true;
        }
    }
    _update() {
        this.apiService.graphql(`project(id: ${this.projectId}){ count: userCount } `).then(data => {
            this.count = data.data.project.count;
        });
    }
    render() {
        if (this.syncError)
            return null;
        if (typeof this.count === 'undefined') {
            return (h("span", null, "\u200C"));
        }
        else {
            return (h("span", null, this.count));
        }
    }
    static get is() { return "coreo-project-user-count"; }
    static get properties() { return {
        "apiCtrl": {
            "connect": "coreo-api"
        },
        "count": {
            "state": true
        },
        "el": {
            "elementRef": true
        },
        "projectId": {
            "type": Number,
            "attr": "project-id"
        },
        "syncError": {
            "state": true
        }
    }; }
}

export { CoreoRecordCountComponent as CoreoProjectUserCount };
