/* tslint:disable */
/**
 * This is an autogenerated file created by the Stencil compiler.
 * It contains typing information for all components that exist in this project.
 */


import './stencil.core';


import {
  CoreoAPIService,
} from './services/coreo';
import {
  chartSource,
} from './components/coreo-chart/types';
import {
  CoreoMapSource,
} from './interface';


export namespace Components {

  interface CoreoApi {
    'create': () => Promise<CoreoAPIService>;
    'src': string;
    'token': string;
  }
  interface CoreoApiAttributes extends StencilHTMLAttributes {
    'src'?: string;
    'token'?: string;
  }

  interface CoreoChart {
    'canvasId': string;
    'projectId': number;
    'sources': chartSource[];
    'type': 'bar' | 'pie' | 'scatter' | 'line';
  }
  interface CoreoChartAttributes extends StencilHTMLAttributes {
    'canvasId'?: string;
    'onChartInitializationError'?: (event: CustomEvent) => void;
    'onChartInitializationSuccess'?: (event: CustomEvent) => void;
    'projectId'?: number;
    'sources'?: chartSource[];
    'type'?: 'bar' | 'pie' | 'scatter' | 'line';
  }

  interface CoreoForm {
    'projectId': number;
    'surveyId': number;
  }
  interface CoreoFormAttributes extends StencilHTMLAttributes {
    'onRecordSubmitFailure'?: (event: CustomEvent) => void;
    'onRecordSubmitSuccess'?: (event: CustomEvent) => void;
    'projectId'?: number;
    'surveyId'?: number;
  }

  interface CoreoLogin {
    'credentialProviders': string[];
    'oauthCbPath': string;
    'projectId': number;
  }
  interface CoreoLoginAttributes extends StencilHTMLAttributes {
    'credentialProviders'?: string[];
    'oauthCbPath'?: string;
    'onLoginFail'?: (event: CustomEvent) => void;
    'onLoginStart'?: (event: CustomEvent) => void;
    'onLoginSuccess'?: (event: CustomEvent) => void;
    'onSignupSuccess'?: (event: CustomEvent) => void;
    'projectId'?: number;
  }

  interface CoreoMapMarkers {
    'cluster': boolean;
    'layerTitle': string;
    'parentId': number;
    'projectId': number;
    'surveyId': string;
    'timeframe': number;
    'verified': boolean;
  }
  interface CoreoMapMarkersAttributes extends StencilHTMLAttributes {
    'cluster'?: boolean;
    'layerTitle'?: string;
    'onMarkerClicked'?: (event: CustomEvent) => void;
    'onRegisterLayer'?: (event: CustomEvent) => void;
    'parentId'?: number;
    'projectId'?: number;
    'surveyId'?: string;
    'timeframe'?: number;
    'verified'?: boolean;
  }

  interface CoreoMapPolylines {
    'groupKey': string;
    'layerTitle': string;
    'projectId': number;
    'surveyId': string;
  }
  interface CoreoMapPolylinesAttributes extends StencilHTMLAttributes {
    'groupKey'?: string;
    'layerTitle'?: string;
    'onRegisterLayer'?: (event: CustomEvent) => void;
    'projectId'?: number;
    'surveyId'?: string;
  }

  interface CoreoMapTilelayer {
    'attribution': string;
    'layerTitle': string;
    'url': string;
  }
  interface CoreoMapTilelayerAttributes extends StencilHTMLAttributes {
    'attribution'?: string;
    'layerTitle'?: string;
    'onRegisterLayer'?: (event: CustomEvent) => void;
    'url'?: string;
  }

  interface CoreoMap {
    /**
    * Public API
    */
    'getMap': () => Promise<any>;
    'projectId': string;
  }
  interface CoreoMapAttributes extends StencilHTMLAttributes {
    'projectId'?: string;
  }

  interface CoreoMapbox {
    'enableCtrl': boolean;
    'limit': number;
    'mapStyle': string;
    'mapboxToken': string;
    'pointStyle': 'circle' | 'marker';
    'projectId': number;
    'resizeMap': () => void;
    'showMapControls': boolean;
    'sources': CoreoMapSource[];
  }
  interface CoreoMapboxAttributes extends StencilHTMLAttributes {
    'enableCtrl'?: boolean;
    'limit'?: number;
    'mapStyle'?: string;
    'mapboxToken'?: string;
    'onOnPointClicked'?: (event: CustomEvent) => void;
    'pointStyle'?: 'circle' | 'marker';
    'projectId'?: number;
    'showMapControls'?: boolean;
    'sources'?: CoreoMapSource[];
  }

  interface CoreoPiechart {}
  interface CoreoPiechartAttributes extends StencilHTMLAttributes {}

  interface CoreoProjectUserCount {
    'projectId': number;
  }
  interface CoreoProjectUserCountAttributes extends StencilHTMLAttributes {
    'projectId'?: number;
  }

  interface CoreoProjectUserLeaderboard {
    'limit': number;
    'projectId': number;
  }
  interface CoreoProjectUserLeaderboardAttributes extends StencilHTMLAttributes {
    'limit'?: number;
    'projectId'?: number;
  }

  interface CoreoRecordAttributes {
    'hideMedia': boolean;
    'limit': number;
    'placeholderLength': number;
    'recordId': string;
  }
  interface CoreoRecordAttributesAttributes extends StencilHTMLAttributes {
    'hideMedia'?: boolean;
    'limit'?: number;
    'placeholderLength'?: number;
    'recordId'?: string;
  }

  interface CoreoRecordCard {
    'photoField': string;
    'recordId': string;
  }
  interface CoreoRecordCardAttributes extends StencilHTMLAttributes {
    'photoField'?: string;
    'recordId'?: string;
  }

  interface CoreoRecordCards {
    'limit': number;
    'surveyId': string;
  }
  interface CoreoRecordCardsAttributes extends StencilHTMLAttributes {
    'limit'?: number;
    'surveyId'?: string;
  }

  interface CoreoRecordImageCover {
    'projectId': number;
    'recordId': number;
  }
  interface CoreoRecordImageCoverAttributes extends StencilHTMLAttributes {
    'projectId'?: number;
    'recordId'?: number;
  }

  interface CoreoRecordImageSlider {
    'projectId': number;
    'recordId': number;
    'slideInterval': number;
  }
  interface CoreoRecordImageSliderAttributes extends StencilHTMLAttributes {
    'projectId'?: number;
    'recordId'?: number;
    'slideInterval'?: number;
  }

  interface CoreoRecordImage {
    'alt': string;
    'path': string;
    'recordId': number;
  }
  interface CoreoRecordImageAttributes extends StencilHTMLAttributes {
    'alt'?: string;
    'path'?: string;
    'recordId'?: number;
  }

  interface CoreoRecordList {
    'limit': number;
    'order': string;
    'parentId': number;
    'projectId': number;
    'surveyId': string;
    'timeframe': number;
    'verified': boolean;
  }
  interface CoreoRecordListAttributes extends StencilHTMLAttributes {
    'limit'?: number;
    'onRecordClicked'?: (event: CustomEvent) => void;
    'order'?: string;
    'parentId'?: number;
    'projectId'?: number;
    'surveyId'?: string;
    'timeframe'?: number;
    'verified'?: boolean;
  }

  interface CoreoRecordQuery {
    'distinct': boolean;
    'fn': string;
    'parentId': number;
    'path': string;
    'projectId': number;
    'surveyId': string;
    'timeframe': number;
    'verified': boolean;
  }
  interface CoreoRecordQueryAttributes extends StencilHTMLAttributes {
    'distinct'?: boolean;
    'fn'?: string;
    'parentId'?: number;
    'path'?: string;
    'projectId'?: number;
    'surveyId'?: string;
    'timeframe'?: number;
    'verified'?: boolean;
  }

  interface CoreoRecordTableColumn {
    'attr': string;
    'label': string;
  }
  interface CoreoRecordTableColumnAttributes extends StencilHTMLAttributes {
    'attr'?: string;
    'label'?: string;
    'onRegisterColumn'?: (event: CustomEvent) => void;
  }

  interface CoreoRecordTable {
    'projectId': number;
    'surveyId': string;
  }
  interface CoreoRecordTableAttributes extends StencilHTMLAttributes {
    'projectId'?: number;
    'surveyId'?: string;
  }

  interface CoreoSpinner {}
  interface CoreoSpinnerAttributes extends StencilHTMLAttributes {}
}

declare global {
  interface StencilElementInterfaces {
    'CoreoApi': Components.CoreoApi;
    'CoreoChart': Components.CoreoChart;
    'CoreoForm': Components.CoreoForm;
    'CoreoLogin': Components.CoreoLogin;
    'CoreoMapMarkers': Components.CoreoMapMarkers;
    'CoreoMapPolylines': Components.CoreoMapPolylines;
    'CoreoMapTilelayer': Components.CoreoMapTilelayer;
    'CoreoMap': Components.CoreoMap;
    'CoreoMapbox': Components.CoreoMapbox;
    'CoreoPiechart': Components.CoreoPiechart;
    'CoreoProjectUserCount': Components.CoreoProjectUserCount;
    'CoreoProjectUserLeaderboard': Components.CoreoProjectUserLeaderboard;
    'CoreoRecordAttributes': Components.CoreoRecordAttributes;
    'CoreoRecordCard': Components.CoreoRecordCard;
    'CoreoRecordCards': Components.CoreoRecordCards;
    'CoreoRecordImageCover': Components.CoreoRecordImageCover;
    'CoreoRecordImageSlider': Components.CoreoRecordImageSlider;
    'CoreoRecordImage': Components.CoreoRecordImage;
    'CoreoRecordList': Components.CoreoRecordList;
    'CoreoRecordQuery': Components.CoreoRecordQuery;
    'CoreoRecordTableColumn': Components.CoreoRecordTableColumn;
    'CoreoRecordTable': Components.CoreoRecordTable;
    'CoreoSpinner': Components.CoreoSpinner;
  }

  interface StencilIntrinsicElements {
    'coreo-api': Components.CoreoApiAttributes;
    'coreo-chart': Components.CoreoChartAttributes;
    'coreo-form': Components.CoreoFormAttributes;
    'coreo-login': Components.CoreoLoginAttributes;
    'coreo-map-markers': Components.CoreoMapMarkersAttributes;
    'coreo-map-polylines': Components.CoreoMapPolylinesAttributes;
    'coreo-map-tilelayer': Components.CoreoMapTilelayerAttributes;
    'coreo-map': Components.CoreoMapAttributes;
    'coreo-mapbox': Components.CoreoMapboxAttributes;
    'coreo-piechart': Components.CoreoPiechartAttributes;
    'coreo-project-user-count': Components.CoreoProjectUserCountAttributes;
    'coreo-project-user-leaderboard': Components.CoreoProjectUserLeaderboardAttributes;
    'coreo-record-attributes': Components.CoreoRecordAttributesAttributes;
    'coreo-record-card': Components.CoreoRecordCardAttributes;
    'coreo-record-cards': Components.CoreoRecordCardsAttributes;
    'coreo-record-image-cover': Components.CoreoRecordImageCoverAttributes;
    'coreo-record-image-slider': Components.CoreoRecordImageSliderAttributes;
    'coreo-record-image': Components.CoreoRecordImageAttributes;
    'coreo-record-list': Components.CoreoRecordListAttributes;
    'coreo-record-query': Components.CoreoRecordQueryAttributes;
    'coreo-record-table-column': Components.CoreoRecordTableColumnAttributes;
    'coreo-record-table': Components.CoreoRecordTableAttributes;
    'coreo-spinner': Components.CoreoSpinnerAttributes;
  }


  interface HTMLCoreoApiElement extends Components.CoreoApi, HTMLStencilElement {}
  var HTMLCoreoApiElement: {
    prototype: HTMLCoreoApiElement;
    new (): HTMLCoreoApiElement;
  };

  interface HTMLCoreoChartElement extends Components.CoreoChart, HTMLStencilElement {}
  var HTMLCoreoChartElement: {
    prototype: HTMLCoreoChartElement;
    new (): HTMLCoreoChartElement;
  };

  interface HTMLCoreoFormElement extends Components.CoreoForm, HTMLStencilElement {}
  var HTMLCoreoFormElement: {
    prototype: HTMLCoreoFormElement;
    new (): HTMLCoreoFormElement;
  };

  interface HTMLCoreoLoginElement extends Components.CoreoLogin, HTMLStencilElement {}
  var HTMLCoreoLoginElement: {
    prototype: HTMLCoreoLoginElement;
    new (): HTMLCoreoLoginElement;
  };

  interface HTMLCoreoMapMarkersElement extends Components.CoreoMapMarkers, HTMLStencilElement {}
  var HTMLCoreoMapMarkersElement: {
    prototype: HTMLCoreoMapMarkersElement;
    new (): HTMLCoreoMapMarkersElement;
  };

  interface HTMLCoreoMapPolylinesElement extends Components.CoreoMapPolylines, HTMLStencilElement {}
  var HTMLCoreoMapPolylinesElement: {
    prototype: HTMLCoreoMapPolylinesElement;
    new (): HTMLCoreoMapPolylinesElement;
  };

  interface HTMLCoreoMapTilelayerElement extends Components.CoreoMapTilelayer, HTMLStencilElement {}
  var HTMLCoreoMapTilelayerElement: {
    prototype: HTMLCoreoMapTilelayerElement;
    new (): HTMLCoreoMapTilelayerElement;
  };

  interface HTMLCoreoMapElement extends Components.CoreoMap, HTMLStencilElement {}
  var HTMLCoreoMapElement: {
    prototype: HTMLCoreoMapElement;
    new (): HTMLCoreoMapElement;
  };

  interface HTMLCoreoMapboxElement extends Components.CoreoMapbox, HTMLStencilElement {}
  var HTMLCoreoMapboxElement: {
    prototype: HTMLCoreoMapboxElement;
    new (): HTMLCoreoMapboxElement;
  };

  interface HTMLCoreoPiechartElement extends Components.CoreoPiechart, HTMLStencilElement {}
  var HTMLCoreoPiechartElement: {
    prototype: HTMLCoreoPiechartElement;
    new (): HTMLCoreoPiechartElement;
  };

  interface HTMLCoreoProjectUserCountElement extends Components.CoreoProjectUserCount, HTMLStencilElement {}
  var HTMLCoreoProjectUserCountElement: {
    prototype: HTMLCoreoProjectUserCountElement;
    new (): HTMLCoreoProjectUserCountElement;
  };

  interface HTMLCoreoProjectUserLeaderboardElement extends Components.CoreoProjectUserLeaderboard, HTMLStencilElement {}
  var HTMLCoreoProjectUserLeaderboardElement: {
    prototype: HTMLCoreoProjectUserLeaderboardElement;
    new (): HTMLCoreoProjectUserLeaderboardElement;
  };

  interface HTMLCoreoRecordAttributesElement extends Components.CoreoRecordAttributes, HTMLStencilElement {}
  var HTMLCoreoRecordAttributesElement: {
    prototype: HTMLCoreoRecordAttributesElement;
    new (): HTMLCoreoRecordAttributesElement;
  };

  interface HTMLCoreoRecordCardElement extends Components.CoreoRecordCard, HTMLStencilElement {}
  var HTMLCoreoRecordCardElement: {
    prototype: HTMLCoreoRecordCardElement;
    new (): HTMLCoreoRecordCardElement;
  };

  interface HTMLCoreoRecordCardsElement extends Components.CoreoRecordCards, HTMLStencilElement {}
  var HTMLCoreoRecordCardsElement: {
    prototype: HTMLCoreoRecordCardsElement;
    new (): HTMLCoreoRecordCardsElement;
  };

  interface HTMLCoreoRecordImageCoverElement extends Components.CoreoRecordImageCover, HTMLStencilElement {}
  var HTMLCoreoRecordImageCoverElement: {
    prototype: HTMLCoreoRecordImageCoverElement;
    new (): HTMLCoreoRecordImageCoverElement;
  };

  interface HTMLCoreoRecordImageSliderElement extends Components.CoreoRecordImageSlider, HTMLStencilElement {}
  var HTMLCoreoRecordImageSliderElement: {
    prototype: HTMLCoreoRecordImageSliderElement;
    new (): HTMLCoreoRecordImageSliderElement;
  };

  interface HTMLCoreoRecordImageElement extends Components.CoreoRecordImage, HTMLStencilElement {}
  var HTMLCoreoRecordImageElement: {
    prototype: HTMLCoreoRecordImageElement;
    new (): HTMLCoreoRecordImageElement;
  };

  interface HTMLCoreoRecordListElement extends Components.CoreoRecordList, HTMLStencilElement {}
  var HTMLCoreoRecordListElement: {
    prototype: HTMLCoreoRecordListElement;
    new (): HTMLCoreoRecordListElement;
  };

  interface HTMLCoreoRecordQueryElement extends Components.CoreoRecordQuery, HTMLStencilElement {}
  var HTMLCoreoRecordQueryElement: {
    prototype: HTMLCoreoRecordQueryElement;
    new (): HTMLCoreoRecordQueryElement;
  };

  interface HTMLCoreoRecordTableColumnElement extends Components.CoreoRecordTableColumn, HTMLStencilElement {}
  var HTMLCoreoRecordTableColumnElement: {
    prototype: HTMLCoreoRecordTableColumnElement;
    new (): HTMLCoreoRecordTableColumnElement;
  };

  interface HTMLCoreoRecordTableElement extends Components.CoreoRecordTable, HTMLStencilElement {}
  var HTMLCoreoRecordTableElement: {
    prototype: HTMLCoreoRecordTableElement;
    new (): HTMLCoreoRecordTableElement;
  };

  interface HTMLCoreoSpinnerElement extends Components.CoreoSpinner, HTMLStencilElement {}
  var HTMLCoreoSpinnerElement: {
    prototype: HTMLCoreoSpinnerElement;
    new (): HTMLCoreoSpinnerElement;
  };

  interface HTMLElementTagNameMap {
    'coreo-api': HTMLCoreoApiElement
    'coreo-chart': HTMLCoreoChartElement
    'coreo-form': HTMLCoreoFormElement
    'coreo-login': HTMLCoreoLoginElement
    'coreo-map-markers': HTMLCoreoMapMarkersElement
    'coreo-map-polylines': HTMLCoreoMapPolylinesElement
    'coreo-map-tilelayer': HTMLCoreoMapTilelayerElement
    'coreo-map': HTMLCoreoMapElement
    'coreo-mapbox': HTMLCoreoMapboxElement
    'coreo-piechart': HTMLCoreoPiechartElement
    'coreo-project-user-count': HTMLCoreoProjectUserCountElement
    'coreo-project-user-leaderboard': HTMLCoreoProjectUserLeaderboardElement
    'coreo-record-attributes': HTMLCoreoRecordAttributesElement
    'coreo-record-card': HTMLCoreoRecordCardElement
    'coreo-record-cards': HTMLCoreoRecordCardsElement
    'coreo-record-image-cover': HTMLCoreoRecordImageCoverElement
    'coreo-record-image-slider': HTMLCoreoRecordImageSliderElement
    'coreo-record-image': HTMLCoreoRecordImageElement
    'coreo-record-list': HTMLCoreoRecordListElement
    'coreo-record-query': HTMLCoreoRecordQueryElement
    'coreo-record-table-column': HTMLCoreoRecordTableColumnElement
    'coreo-record-table': HTMLCoreoRecordTableElement
    'coreo-spinner': HTMLCoreoSpinnerElement
  }

  interface ElementTagNameMap {
    'coreo-api': HTMLCoreoApiElement;
    'coreo-chart': HTMLCoreoChartElement;
    'coreo-form': HTMLCoreoFormElement;
    'coreo-login': HTMLCoreoLoginElement;
    'coreo-map-markers': HTMLCoreoMapMarkersElement;
    'coreo-map-polylines': HTMLCoreoMapPolylinesElement;
    'coreo-map-tilelayer': HTMLCoreoMapTilelayerElement;
    'coreo-map': HTMLCoreoMapElement;
    'coreo-mapbox': HTMLCoreoMapboxElement;
    'coreo-piechart': HTMLCoreoPiechartElement;
    'coreo-project-user-count': HTMLCoreoProjectUserCountElement;
    'coreo-project-user-leaderboard': HTMLCoreoProjectUserLeaderboardElement;
    'coreo-record-attributes': HTMLCoreoRecordAttributesElement;
    'coreo-record-card': HTMLCoreoRecordCardElement;
    'coreo-record-cards': HTMLCoreoRecordCardsElement;
    'coreo-record-image-cover': HTMLCoreoRecordImageCoverElement;
    'coreo-record-image-slider': HTMLCoreoRecordImageSliderElement;
    'coreo-record-image': HTMLCoreoRecordImageElement;
    'coreo-record-list': HTMLCoreoRecordListElement;
    'coreo-record-query': HTMLCoreoRecordQueryElement;
    'coreo-record-table-column': HTMLCoreoRecordTableColumnElement;
    'coreo-record-table': HTMLCoreoRecordTableElement;
    'coreo-spinner': HTMLCoreoSpinnerElement;
  }


}
