import '../../stencil.core';
import { EventEmitter } from '../../stencil.core';
import { ICoreoAPIController } from '../coreo-api/coreo-api.interface';
import { CoreoAPIService } from '../../services/coreo';
import { chartSource } from './types';
export declare class CoreoChartComponent {
    el: HTMLElement;
    apiCtrl: ICoreoAPIController;
    projectId: number;
    type: 'bar' | 'pie' | 'scatter' | 'line';
    sources: chartSource[];
    validateSources(newValue: chartSource[], _oldValue: chartSource[]): void;
    canvasId: string;
    chartInitializationSuccess: EventEmitter;
    chartInitializationError: EventEmitter;
    syncError: boolean;
    labels: string[];
    dataHasLoaded: boolean[];
    chartWillLoad: boolean;
    chartInitError: boolean;
    keyValueDatasets: Map<string, number>[];
    numericalPairDatasets: {
        x: number;
        y: number;
    }[][];
    cronologicalDatasets: {
        t: Date;
        y: number;
    }[][];
    chart: Chart;
    /**
     * Default colors.
     *  TODO:
     *  - Add more colors to avoid repetition
     *  - Make them customizable via Props.
     *  - Add a patterns attribute for color-blind visualization, use https://github.com/ashiguruma/patternomaly
     **/
    defaultColors: string[];
    apiService: CoreoAPIService;
    componentWillLoad(): void;
    _update(): void;
    initialiseLabels(): void;
    initialiseKeyValueDataset(datasetIndex: number): void;
    initialiseNumericalPairDataset(datasetIndex: number): void;
    initialiseLineDataset(datasetIndex: number): void;
    checkIfChartLoaded(): void;
    drawChart(): void;
    drawBarChart(): void;
    drawPieChart(): void;
    drawScatterChart(): void;
    drawLineChart(): void;
    render(): JSX.Element;
}
