import '../../stencil.core';
import { EventEmitter } from '../../stencil.core';
import { ICoreoAPIController } from '../coreo-api/coreo-api.interface';
import { CoreoAPIService } from '../../services/coreo';
export declare class CoreoLoginComponent {
    views: {
        'LOGIN': number;
        'SIGNUP': number;
    };
    el: HTMLElement;
    projectId: number;
    apiCtrl: ICoreoAPIController;
    credentialProviders: string[];
    oauthCbPath: string;
    loginStart: EventEmitter;
    loginSuccess: EventEmitter;
    loginFail: EventEmitter;
    signupSuccess: EventEmitter;
    syncError: boolean;
    view: number;
    loginError: string;
    signupError: string;
    hasSignedUp: boolean;
    apiSrc: string;
    googleEnabled: boolean;
    facebookEnabled: boolean;
    email: {
        valid: boolean;
        value: string;
    };
    password: {
        valid: boolean;
        value: string;
    };
    passwordConfirm: {
        valid: boolean;
        value: string;
    };
    displayName: {
        valid: boolean;
        value: string;
    };
    submitted: boolean;
    apiService: CoreoAPIService;
    componentWillLoad(): void;
    /**
     * Checks to see if any credential providers, if any, are available
     */
    obtainCredentialProviders(): void;
    passwordConfirmed(): boolean;
    localLogin(e: Event): void;
    localSignup(e: Event): void;
    handleEmailChange(event: CustomEvent<KeyboardEvent>): void;
    handlePasswordChange(event: CustomEvent<KeyboardEvent>): void;
    handlePasswordConfirmChange(event: CustomEvent<KeyboardEvent>): void;
    handleDisplayNameChange(event: CustomEvent<KeyboardEvent>): void;
    renderOAuthButton(provider: string, projectId?: number): JSX.Element;
    renderSignIn(): JSX.Element;
    goToSignup(): void;
    cancelSignup(): void;
    renderSignup(): JSX.Element;
    renderSignupSuccess(): JSX.Element;
    render(): JSX.Element;
}
