import '../../stencil.core';
import { EventEmitter } from '../../stencil.core';
import mapboxgl from 'mapbox-gl';
import { ICoreoAPIController } from '../coreo-api/coreo-api.interface';
import { CoreoAPIService } from '../../services/coreo';
import { CoreoMapSource } from '../../interface';
export declare class CoreoMapboxComponent {
    projectId: number;
    sources: CoreoMapSource[];
    limit: number;
    showMapControls: boolean;
    pointStyle: 'circle' | 'marker';
    mapStyle: string;
    mapboxToken: string;
    enableCtrl: boolean;
    map: mapboxgl.Map;
    recordData: any[][];
    iconData: any[][];
    syncError: boolean;
    asyncError: boolean;
    mapUUID: string;
    showCtrlBackdrop: boolean;
    showCtrlBackdropTimeout: boolean;
    lastZoomLevel: number;
    apiCtrl: ICoreoAPIController;
    apiService: CoreoAPIService;
    onPointClicked: EventEmitter;
    onPointClickedHandler(clickedFeature: GeoJSON.Feature<mapboxgl.GeoJSONGeometry, any>, sourceIndex: number): void;
    resizeMap(): void;
    componentWillLoad(): void;
    obtainMapStyleURL(url: string): string;
    componentDidLoad(): void;
    loadRecordData(sourceIndex: number): void;
    formGeoJSONAndRender(sourceIndex: number): void;
    loadSourceIcon(sourceIdx: number): string | string[];
    renderRecordData(geojson: GeoJSON.FeatureCollection<mapboxgl.GeoJSONGeometry>, sourceIndex: number): void;
    addIconToMap(id: string, url: string): Promise<void>;
    configureMap(): Promise<void>;
    ctrlBackdropHandler: (event: WheelEvent) => void;
    render(): JSX.Element[];
}
