export interface ICoreoAPIService {
    graphql(query: string): any;
}
export declare class CoreoError extends Error {
    code: number;
    constructor(msg: string, code: number);
}
export declare class CoreoAPIService implements ICoreoAPIService {
    private token;
    private src;
    private graphqlEndpoint;
    constructor(token: string, src?: string, graphqlEndpoint?: string);
    setToken(token: string): void;
    getToken(): string;
    setSrc(src: string): void;
    getSrc(): string;
    graphql(query: string, operation?: string): Promise<any>;
    post(path: string, body: any, isJson?: boolean): Promise<any>;
    get(path: string): Promise<any>;
}
